// 1. Set the vscripts keyvalue of the trigger to ragdoll_trigger
// 2. if the "target" keyvalue (not targetname!!) is missing from your trigger, 
//    turn off SmartEdit and add the target keyvalue to the trigger
// 3. Set the "target" keyvalue to what ragdoll types you want to use in the following format.
// burn, gold, uber, TF_DMG_CUSTOM_TRIGGER_HURT, TF_DMG_CUSTOM_PLASMA
// the first TF_DMG_CUSTOM_* will be the actual trigger damage and the second will be what the ragdoll will be told to use.
function t_CollectEventsInScope(events)
{
	local events_id = UniqueString()
	getroottable()[events_id] <- events
	local events_table = getroottable()[events_id]
	foreach (name, callback in events) events_table[name] = callback.bindenv(this)
	local cleanup_user_func, cleanup_event = "OnGameEvent_scorestats_accumulated_update"
    if (cleanup_event in events) cleanup_user_func = events[cleanup_event].bindenv(this)
	events_table[cleanup_event] <- function(params)
	{
		if (cleanup_user_func) cleanup_user_func(params)
		delete getroottable()[events_id]
	} __CollectGameEventCallbacks(events_table)
}

if(!("kill_immune_conds" in getroottable()))
{
	::kill_immune_conds <-
	[
		Constants.ETFCond.TF_COND_INVULNERABLE,
		Constants.ETFCond.TF_COND_INVULNERABLE_HIDE_UNLESS_DAMAGED,
		Constants.ETFCond.TF_COND_INVULNERABLE_USER_BUFF,
		Constants.ETFCond.TF_COND_INVULNERABLE_CARD_EFFECT,
		Constants.ETFCond.TF_COND_PHASE,
	]
	getroottable()["ragdoll info table"] <-
	{
		"gib" : "m_bGib"				// m_bGib - seems to just delete the ragdoll if TF_DMG_CUSTOM_CROC is not set
		"burn" : "m_bBurning"			// m_bBurning - adds a burning effect to the ragdoll, set when dying from a source of fire
		"uber" : "m_bElectrocuted"		// m_bElectrocuted - adds some sparks to the ragdoll, set when dying with uber
		"deadringer" : "m_bFeignDeath"	// m_bFeignDeath - seems to have no effect on the ragdoll, set when feigning death with the dead ringer (?) confirm
		"disguise" : "m_bWasDisguised"	// m_bWasDisguised - seems to have no effect on the ragdoll, set when dying while disguised as a spy (?) confirm
		"ash" : "m_bBecomeAsh"			// m_bBecomeAsh - turns the ragdoll into ash particles, set when dying from the phlog
		"cloak" : "m_bCloaked"			// m_bCloaked - fades the ragdoll to be invisible, set when dying from the Your Eternal Reward
		"gold" : "m_bGoldRagdoll"		// m_bGoldRagdoll - turns the ragdoll gold, set when dying to the Saxxy or the Golden Frying Pan
		"ice" : "m_bIceRagdoll"			// m_bIceRagdoll - turns the ragdoll into an ice statue, set when dying to the spy-cicle
	}
}

function Precache()
{
	// Add an output to deal damage when the trigger is touched
	lastvictim <- null
	_damage_type <- 0
	_ragdoll_damage_type <- 0
	self.ConnectOutput("OnStartTouch", "CustomKill")
	// move the following to the CustomKill function if you intend to change the ragdoll effects while the map is running.
	local _type_str = NetProps.GetPropString(self, "m_target")
	_type_arr <- split(_type_str, ",")
	for(local i = 0, c = 0; i < _type_arr.len(); i++)
	{
		_type_arr[i] = lstrip(_type_arr[i])
		local __type = _type_arr[i]
		if(startswith(__type, "TF_DMG_CUSTOM_") || startswith(__type, "Constants.ETFDmgCustom."))
		{
			local __val = compilestring(@"return " + (startswith(__type, "Constants.ETFDmgCustom.") ? __type : ("Constants.ETFDmgCustom." + __type)) + @"")
			if(c == 0)
			{
				_damage_type = __val()
			}
			else
			{
				_ragdoll_damage_type = __val()
			}
			c++
		}
	}
}

function CustomKill()
{
	// Remove conditions that give immunity to damage
	foreach(cond in kill_immune_conds)
		activator.RemoveCondEx(cond, true)

	// Deal the damage with the weapon
	lastvictim = activator
	activator.TakeDamageCustom(self, activator, null, Vector(0,0,0), Vector(0,0,0), 99999, 2080, _damage_type)
	EntFireByHandle(self, "runscriptcode", "lastvictim = null", 0, null, null)
}

t_CollectEventsInScope
({
	// Set the Attributes on the ragdoll
	OnGameEvent_player_death = function(params)
	{
		local player = GetPlayerFromUserID(params.userid)
		if (!player)
			return
		if (player == lastvictim)
		{
			EntFireByHandle(self, "runscriptcode", @"
			local ragdoll_table = getroottable()[`ragdoll info table`]
			if(!lastvictim)
				return
			local ragdoll = NetProps.GetPropEntity(lastvictim, `m_hRagdoll`)
			NetProps.SetPropInt(ragdoll, `m_iDamageCustom`, _ragdoll_damage_type)
			foreach(_type in _type_arr)
			{
				if(_type in ragdoll_table)
					NetProps.SetPropBool(ragdoll, ragdoll_table[_type], true)
			}
			", 0, null, null)
		}
	}
})